# -*- Mode: Python -*-
# vi:si:et:sw=4:sts=4:ts=4

import sys
from v4l.v4l import Device

if __name__ == '__main__':
    try:
        path = sys.argv[1]
    except:
        path = '/dev/video0'

    device = Device(path)


    vcap = device.query()
    print "path: %s" % path
    print "Name: %s" % vcap.name
    print "Size: %dx%d - %dx%d" % (vcap.minwidth, vcap.minheight,
        vcap.maxwidth, vcap.maxheight)
    print "Radio/TV Channels: %d" % vcap.channels
    print "Audio devices: %d" % vcap.audios
    print "Types: %s" % ", ".join(vcap.get_type())

    print
    
    channels = device.get_channels()
    print "Channels: %d" % len(channels)

    for channel in channels:
        print "- Channel %d: " % channel.channel
        print "  - Name: %s" % channel.name
        print "  - Type: %s" % channel.get_type()
        vpic = device.query_video_picture()
        print "  - B/H/C/C: %d %d %d %d" % (vpic.brightness, vpic.hue,
            vpic.colour, vpic.contrast)
        print "  - Palette: %s" % vpic.get_palette()

        device.set_channel(channels.index(channel))
        tuners = None
        tuners = channel.get_tuners()
        print "  - Tuners: %d" % len(tuners)
        if tuners:
            for tuner in tuners:
                print "    - Tuner name: %s" % tuner.name
                print "    - flag value: %d" % tuner.flags
                print "    - flags: %s" % ", ".join(tuner.get_flags())

        print
